#!/bin/sh
# $Id: t-tlsr-cnf-0.sh,v 1.9 2013/11/02 04:34:15 ca Exp $
#

# ---------------------------
# run t-tlsr-cnf-0 with some configuration files
# ---------------------------

test -s stop && exit 1              

PRG=t-tlsr-cnf-0
IN=${PRG}.in
OUT=${PRG}.out
OK=${PRG}.ok

TEST=1
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
cert_issuer="/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org"; cipher_bits_min=590;requirements_violation=permfail;
EOF
cat > ${OK} <<EOF
CN=(null)
CS=(null)
CI=/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org
flags=0
bits=590
hostnames[0]=(null)
ca_subjects[0]=(null)
requirements_violation=permfail
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
grep 'MTA_USE_TLS not set' ${OUT} >/dev/null && exit 0
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi


TEST=2
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
cert_issuer="/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org"; cipher_bits_min=90;flags={verified};
EOF
cat > ${OK} <<EOF
CN=(null)
CS=(null)
CI=/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org
flags=0x1
bits=90
hostnames[0]=(null)
ca_subjects[0]=(null)
requirements_violation=abort
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

TEST=3
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
cert_issuer="/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org"; cipher_bits_min=199;flags={verified};requirements_violation=tempfail;
EOF
cat > ${OK} <<EOF
CN=(null)
CS=(null)
CI=/C=US/ST=California/L=Berkeley/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org
flags=0x1
bits=199
hostnames[0]=(null)
ca_subjects[0]=(null)
requirements_violation=tempfail
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

rm -f ${IN} ${OUT} ${OK}
exit 0
