/*
 */

#include "sm/generic.h"
#include "sm/binsearch.h"
#include "sm/test.h"

static sm_identry_T idtab[] = {
	  { "abc" }
	, { "xzy" }
	, { "defg" }
	, { "xzy0" }
	, { "xzyy" }
	, { "thisisme" }
};

static sm_binlen_T bltabok[] = {
	  { 1, 0 }	/* 0 */
	, { 1, 0 }	/* 1 */
	, { 1, 0 }	/* 2 */
	, { 0, 1 }	/* 3 */
	, { 2, 4 }	/* 4 */
	, { 1, 0 }	/* 5 */
	, { 1, 0 }	/* 6 */
	, { 1, 0 }	/* 7 */
	, { 5, 5 }	/* 8 */
	, { 1, 0 }	/* 9 */
};

static sm_binlen_T bltab[] = {
	  { 1, 0 }	/* 0 */
	, { 1, 0 }	/* 1 */
	, { 1, 0 }	/* 2 */
	, { 0, 1 }	/* 3 */
	, { 2, 4 }	/* 4 */
	, { 1, 0 }	/* 5 */
	, { 1, 0 }	/* 6 */
	, { 1, 0 }	/* 7 */
	, { 5, 5 }	/* 8 */
	, { 1, 0 }	/* 9 */
};

static int Verbose;

void
testb(void)
{
	int i, sz, blsz, idx;

	sz = SM_ARRAY_SIZE(idtab);
	blsz = SM_ARRAY_SIZE(bltab);
	SM_TEST(sm_binleninit(idtab, sz, bltab, blsz) == SM_SUCCESS);
	for (i = 0; i < blsz; i++) {
		SM_TEST(bltab[i].bl_first == bltabok[i].bl_first);
		SM_TEST(bltab[i].bl_last == bltabok[i].bl_last);
	}

	for (i = 0; i < sz; i++) {
		SM_TEST(sm_binlensrch(idtab, sz, bltabok, blsz, idtab[i].idt_id, strlen(idtab[i].idt_id), &idx) == SM_SUCCESS);
		SM_TEST(idx == i);
	}
	SM_TEST(sm_binlensrch(idtab, sz, bltab, blsz, "not", strlen("not"), &idx) != SM_SUCCESS);
}

int
main(int argc, char *argv[])
{
	int c;

	while ((c = getopt(argc, argv, "V")) != -1) {
		switch (c) {
		  case 'V':
			++Verbose;
			break;
		  default:
			return(1);
		}
	}
	sm_test_begin(argc, argv, "test binsearch");
	testb();
	return sm_test_end();
}
