/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: mapconffind.c,v 1.1 2009/07/03 04:47:35 ca Exp $")

#include "sm/error.h"
#include "sm/string.h"
#include "sm/net.h"
#include "sm/maps.h"
#include "sm/mapc.h"
#include "sm/map.h"
#include "map.h"
#include "sm/sm-conf.h"
#include "sm/mapcnf.h"
#include "sm/mapconf.h"

/*
**  SM_MAPCONFFIND -- find a map by name (in list of map declarations)
**
**	Parameters:
**		mapdef -- map configuration
**		map_name -- name of map
**
**	Returns:
**		pointer to map specification
*/

mapspec_P
sm_mapconffind(map_decl_P mapdef, const char *map_name)
{
	uint n;
	mapspec_P md_maps;

	SM_REQUIRE(mapdef != NULL);
	for (n = 0; n < mapdef->mapdecl_n; n++) {
		md_maps = mapdef->mapdecl_maps + n;
		if (NULL == md_maps)
			continue;
		if (strcmp(md_maps->mst_name, map_name) == 0)
			return md_maps;
	}
	return NULL;
}
