#!/bin/sh
# $Id: t-conf-0.sh,v 1.2 2013/12/23 01:37:48 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.

# ---------------------------
# invoke mcp to print some configuration files, check return codes
# ---------------------------

test -s stop && exit 1              

PRG=./mcp
T=`basename $0 .sh`
CONF=${T}.conf
OUT=${T}.out
ERR=0

runtest()
{
  EEC=$1

  $PRG -i "" -p mcp.pid -L . -D -T ${CONF} >${OUT} 2>&1
  EC=$?
  if [ ${EC} -ne ${EEC} ]
  then
    echo "$0: exit code=${EC}, expected=${EEC}"
    ERR=1
    return 1
  fi
  return 0
}

# ---------------------------
# config file ok
TEST=1
rm -f ${CONF} ${OUT}
cat > ${CONF} <<EOF
smtps {
  listen_socket { type=inet; port = 2225; }
  start_action = pass;
  pass_fd_socket = smtpsfd;
  user = ${USER};
  path = "../smtps/smtps";
  arguments = "smtps -f ${CONF}";
}
EOF
runtest 0

# ---------------------------
# broken config file
TEST=2
rm -f ${CONF} ${OUT}
cat > ${CONF} <<EOF
smtps { start_action=bogus; }
EOF
runtest 78

# rm -f ${CONF} ${OUT}

exit $ERR
