#!/bin/sh
# $Id: t-exit-3.sh,v 1.3 2013/12/23 00:21:44 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test restart: program is not executable
# ----------------------------------------
#

CONF=exit.conf
L1=exit.log
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
. ${SD}/common.sh

P=t-exit
rm -f ${PIDS} ${OUT} ${L1}
cat > ${CONF} <<EOF
exit {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./$P;
	arguments = "$P -f ${CNTF} -s 1 -e 69";
}
EOF
chmod -x $P
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}
sleep 2
if grep "$P.* exit=configuration error" ${OUT} >/dev/null
then
  if grep "service terminated" ${OUT} >/dev/null
  then
    :
  else
    ${VERBOSE} && echo "missing service terminated in ${OUT}"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ${VERBOSE} && echo "missing configuration error in ${OUT}"
  ERRS=`expr ${ERRS} + 1 `
fi

stopit

chmod u+x $P
exit ${ERRS}
