#!/bin/sh
# $Id: t-iqdb-0.sh,v 1.4 2011/01/31 16:13:21 ca Exp $
#
# Copyright (c) 2010 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test IQDB error handling
# uses t-iqdb-0
# ----------------------------------------
#
test -s stop && exit 1
#
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../qmgr
fi

GREP=grep
ERR=false
ERRS=0
if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TPRG=./t-iqdb-0
OUT=iqdb-0.out

chkqlog()
{
  grep '^SKIPPED' ${OUT} >/dev/null && return 0
  for p in 'IQDB usage *= *0 ' 'IQDB current *= *0$' 'IBDB open TAs   =0$' 'IBDB open RCPTs =0$'
  do
     if grep "$p" ${OUT} >/dev/null
     then
       :
     else
       echo "$0: test ${TEST} failed: missing $p in ${OUT}"
       return 1
     fi
  done
  return 0
}

$SD/../chkmts/mta-setup.sh

# ----------------------------------------
# test with default parameters: TA overflows IQDB
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if $TPRG > ${OUT} 2>&1
then
  if chkqlog
  then
    ${VERBOSE} && echo "test ${TEST} succeeded"
  else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  echo "$0: test ${TEST} failed"
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# RCPT overflows IQDB
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if $TPRG -r 33 > ${OUT} 2>&1
then
  if chkqlog
  then
    ${VERBOSE} && echo "test ${TEST} succeeded"
  else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  echo "$0: test ${TEST} failed"
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  rm -f ${OUT}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
